/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/*  CMetrics
 *  ========
 *  Copyright 2021-2022 The CMetrics Authors
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#include <cmetrics/cmt_info.h>
#include <inttypes.h>
#include <time.h>

void cmt_time_from_ns(struct timespec *tm, uint64_t ns)
{
    if (ns < 1000000000L) {
        tm->tv_sec = 0;
        tm->tv_nsec = ns;
    }
    else {
        tm->tv_sec = ns / 1000000000L;
        tm->tv_nsec = ns - (tm->tv_sec * 1000000000L);
    }
}
