/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/*  Monkey HTTP Server
 *  ==================
 *  Copyright 2001-2016 Monkey Software LLC <eduardo@monkey.io>
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#ifndef MK_STATIC_PLUGINS_H
#define MK_STATIC_PLUGINS_H

#include <monkey/mk_core.h>
#include <monkey/mk_plugin.h>
#include <monkey/mk_plugin_net.h>

extern struct mk_plugin mk_plugin_liana;


static int mk_static_plugin_attach(struct mk_list *plugins,
                                   struct mk_plugin *plugin)
{
    struct mk_plugin *instance;
    struct mk_plugin_network *network;

    instance = mk_mem_alloc_z(sizeof(struct mk_plugin));

    if (instance == NULL) {
        return MK_FALSE;
    }

    memcpy(instance, plugin, sizeof(struct mk_plugin));

    network = mk_mem_alloc(sizeof(struct mk_plugin_network));

    if (network == NULL) {
        mk_mem_free(instance);

        return MK_FALSE;
    }

    memcpy(network, plugin->network, sizeof(struct mk_plugin_network));

    instance->network = network;

    mk_list_add(&instance->_head, plugins);

    return MK_TRUE;
}

static void mk_static_plugins(struct mk_list *plugins)
{
    struct mk_plugin *p;

    (void) p;

    
    mk_static_plugin_attach(plugins, &mk_plugin_liana);

}

#endif
